#include	"Samp_Main.h"
#include	"Samp_Play.h"
#include	"Samp_Stop.h"
#include	"Samp_Lib.h"
#include	"Samp_Key.h"

void 	SampledaMainLoop(void){


	UI_result = OK;
	
	SampleInitGValid();						/* eXgRg */
	SamplePlayInfoUpdate(LOADING);			/* eXgRg */

	while(1){

		while(1){

			SampleCheckMsg(msg); 				/* eXgRg */

			if (!(tsk & MAIN_TSK_SAMP1) && (((ROC_TIME2MEDIA *)msg)->tsk != PROC_INTERFACE)) {	/* eXgRg */
			}

			if( msg->tsk == PROC_INTERFACE){			/* eXgRg */
				UI_result = SampleCheckInterfaceKey( (Meia_If2Samp_COM *)msg );

			}else if( msg->tsk == TSK_SAMPLE ){
				if( msg->cmd == MSG_Samp_KEY_TIMER ){

					NaviSendInterfaceMsg(UI_msg, UI_result);

					if(GlobalTstnow_mode == NOW_MEDIA_STOP){
						Timer1msStart(Samp_KEY_TIMER, 20, SampleKeyTimer );				/* eXgRg */
					}else{
						Timer1msStart(Samp_KEY_TIMER, Samp_KEY_TIME, SampleKeyTimer );	/* eXgRg */
					}
				}
			}
			break;		/*eXgRg*/
		}

		do {
			ret_cd = SampledaMain( &mda_sts, msg );
		} while( ret_cd == RET_CODEN );

	}
}

void 	SamDcdMainLoop(void){


	UI_result = OK;

	SampleInitGValid();						/* eXgRg */
	SamplePlayInfoUpdate(LOADING);			/* eXgRg */

	while(1){

		while(1){

			SampleCheckMsg(msg); 				/* eXgRgeXgRg */

			break;				/*eXgRg*/
		}

		do {
			ret_cd = SamDcdMain( &dtsSamp_state, msg );
		} while( ret_cd == RET_CODEN );


		if( ret_cd == SAMPLE_END ){
			break;
		}

	}

	tsk = 0;								

}

UC1		SampledaMain(MEDIA_STATE *mda_sts, MSG_ID *msg)
{

	UC1	ercd1;

	switch(*mda_sts){
		default:
			return(SAMP_WAIT);


		case MEDIA_ENTRY:
			target_track = 0xFFFF;
			GlobalTststart_tno = BCD_CHG_BIN(GlobalTsttoc_stno);
			GlobalTstend_tno = BCD_CHG_BIN(GlobalTsttoc_ltno);
			Assert(ercd == E_OK || ercd == E_TMOUT || ercd == E_RLWAI);
			MediaIfTotalptt(0,1);
			SamplePlayInfoUpdate(PLAYWAIT);				/* PLAYWAITIF֕Ԃ 	*/
			return(SAMP_WAIT);


		case	MEDIA_PLAY_WAIT:
			if(msg->tsk == PROC_INTERFACE ){
				if(GlobalTstend_mode == TGT_DA_STOP || GlobalTstend_mode == TGT_DA_OPEN){								/* ~vmF */
					*mda_sts = MEDIA_STOP_WAIT;							/* ~ԑJ */
					return(RET_CODEN);
				}else if(GlobalTstend_mode <= TGT_DA_ACCESS){
					*mda_sts = MEDIA_INIT_DEC;							/* XgbvJ	*/
					return(RET_CODEN);
				}	
			}
			return(SAMP_WAIT);

		case MEDIA_INIT_DEC:
			ercd1 = MainSamInidecMedia(0, AudioSts.sound, &setup);
			return(SAMP_WAIT);

		case MEDIA_GETTOC:
			return(SAMP_WAIT);

		case MEDIA_PLAY:

			while(1){
				ret_cd = SampledaPlay( &media_play_sts, msg, (UC1*)&GlobalTstnow_mode, (UC1*)&GlobalTstend_mode );
			}
			break;

		case MEDIA_PLAY_END_WAIT:

			if( target_track != 0xFFFF ){			
				*mda_sts = MEDIA_AV_CMD_WAIT;
				media_play_sts = 0x0000;			
				return( RET_CODEN );
			}

		case MEDIA_ERROR:
			return(SAMP_WAIT);
	}
}

void 	SampleKeyTimer(void)
{
	ER		ercd;

	GlobalTsttimer2navi_ifmsg.tsk = TSK_SAMPLE;
	GlobalTsttimer2navi_ifmsg.cmd = MSG_Samp_KEY_TIMER;

} 

void SampleInitPlayState(void){

	da_read_state = 0;
	da_scastate = 0;
	da_pause_state = 0;
	da_seek_state = 0;
	Samp_da_pause_req = 0;
}

void SampleInitOpenValue(void)
{
	Samp_memory_mode = 0;
}

RETCODE	SampleCheckMsg(MSG_ID *msg)
{
	RETCODE		ercd;

	ercd = OK;

	return(ercd);
}

